set EditErrors = ask("Edit compilation errors?")
set RunMmimp = ask("Run code improver on object files?")
set NewestOFile = 0
set AnyCompiled = 0
set AnyErrors = 0
set NoLink = 0

foreach CFile in (CKM:CKMKEY.C CKM:CKMKE2.C CKM:CKMKE3.C)
    {
    print $CFile
    set OFile = upto($CFile,".") >< ".o"
    if (!exists($OFile) || mdate($CFile) > mdate($OFile))
	{
	set AnyCompiled = 1
	Megamax_C:mmcc $CFile
	if (status() == 2)
	    {
	    set AnyErrors = 1
	    if ($EditErrors)
		Megamax_C:Editor Megamax_C:errors.out $CFile
	    }
	if (exists($OFile))
	    {
	    if ($RunMmimp)
		{
		Megamax_C:mmimp $OFile
		if (status() == 2)
		    {
		    set AnyErrors = 1
		    if (!exists($OFile))
			set NoLink = 1
		    }
		}
	    }
	else
	    {
	    set AnyErrors = 1
	    set NoLink = 1
	    }
	}
    if (exists($OFile))
	if (mdate($OFile) > $NewestOFile)
	    set NewestOFile = mdate($OFile)
    }

if ($NoLink)
    print "CKM:CKMKEY not being linked due to previous errors."
else if ($AnyCompiled ||	\
    !exists(CKM:CKMKEY) ||	\
    $NewestOFile > mdate(CKM:CKMKEY))
    {
    if ($AnyErrors)
	set AnyErrors = ~ask("Link CKM:CKMKEY after previous errors?")
    if (!$AnyErrors)
	Megamax_C:mmlink \
	    CKM:CKMKEY.o CKM:CKMKE2.o \
	    CKM:CKMKE3.o -o CKM:CKMKEY
    }
else
    print "CKM:CKMKEY is up to date."

